<?php
/**
 * Joomla-Plugin formativ.net Analytics
 * Gibt das Google Analytics Tracking Javascript aus.
 * 
 * @version	1.0
 * @package	Joomla.Site
 * @subpackage	fnet_analytics
 * @author      Thomas Langer
 * @copyright	Copyright (C) 2015 formativ.net oHG.
 * @license	GNU General Public License version 2 or later; see LICENSE.txt
 * 
 */
// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );

jimport( 'joomla.plugin.plugin');
jimport( 'joomla.html.parameter');

class plgSystemFnet_analytics extends JPlugin
{
	/**
	 * 
	 * @param type $subject
	 * @param type $config
	 */
	function plgSystemFnet_Analytics(&$subject, $config)
	{
		parent::__construct($subject, $config);
		$this->_plugin = JPluginHelper::getPlugin( 'system', 'fnet_analytics' );
		$this->_params = new JRegistry( $this->_plugin->params );
	}
	
	/**
	 * 
	 * @return boolean
	 */
	function onAfterRender()
	{
		$mainframe  = JFactory::getApplication();
		$googleid   = $this->params->get('google_id', '');
		$trackingjs = $this->params->get('trackingjs','');
		
		if(($googleid == '' & $trackingjs == '') || $mainframe->isAdmin() || strpos($_SERVER["PHP_SELF"], "index.php") === false)
		{
		    return;
		}
		
		$anonymizeip = $this->params->get('anonymizeip', '');
		$domainname  = $this->params->get('domainname', '');
		$codeposition= $this->params->get('codeposition', '');
		$optoutcookie= $this->params->get('optoutcookie', '');
		
		$buffer = JResponse::getBody();
		
		
		if ($anonymizeip){
			$googleanonymizeip = "  ga('set', 'anonymizeIp', true);"."\n";
		} else {
			$googleanonymizeip='';
		}
		
		if ($domainname){
		    $googledomainname = "  _gaq.push(['_setDomainName', '". $domainname ."']);"."\n";
		} else {
			$domainname ='auto';
		}
		
		if ($optoutcookie){
		    $optoutcookie = <<<GOOGLEANALYTICSOPTOUT
var gaProperty = '$googleid';
var disableStr = 'ga-disable-' + gaProperty;
if (document.cookie.indexOf(disableStr + '=true') > -1) {
  window[disableStr] = true;
}
function gaOptout() {
  document.cookie = disableStr + '=true; expires=Thu, 31 Dec 2099 23:59:59 UTC; path=/';
  window[disableStr] = true;
}
GOOGLEANALYTICSOPTOUT;
		} else {
			$optoutcookie ='';
		}
		
$js = <<<GOOGLEANALYTICS
<script type="text/javascript">
$optoutcookie
(function(i,s,o,g,r,a,m){i['GoogleAnalyticsObject']=r;i[r]=i[r]||function(){(i[r].q=i[r].q||[]).push(arguments)},i[r].l=1*new Date();a=s.createElement(o), m=s.getElementsByTagName(o)[0];
a.async=1;a.src=g;m.parentNode.insertBefore(a,m)})(window,document,'script','//www.google-analytics.com/analytics.js','ga');
ga('create', '$googleid', '$domainname');
ga('send', 'pageview');
$googleanonymizeip
</script>
GOOGLEANALYTICS;

		// Benutzer Trackincode verwenden
		if ($trackingjs){
			$js='<script type="text/javascript">'.$trackingjs.'</script>';
		}
		if (!$codeposition)
		{
		    $buffer = str_replace ("</head>", $js . "</head>", $buffer);
		}
		else
		{
		    $buffer = str_replace ("</body>", $js . "</body>", $buffer);
		}
		JResponse::setBody($buffer);
		return true;
	}
}